﻿<%@ WebService Language="C#" Class="Words" %>

using System;
using System.Collections.Generic;
using System.IO;
using System.Web;
using System.Web.Caching;
using System.Web.Services;
using System.Web.Services.Protocols;
using System.Web.Script.Services;

[ScriptService]
[WebService(Namespace = "http://le.roy.name/words")]
[WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
public class Words  : System.Web.Services.WebService {
    [WebMethod]
    [ScriptMethod]
    public List<string> GetWords(string prefixText) {
        Cache cache = HttpContext.Current.Cache;
        List<string> wordList = cache["WordList"] as List<string>;
        if (wordList == null) {
            wordList = new List<string>();
            using (TextReader reader = new StreamReader(
                Server.MapPath("~/App_Data/words.txt"))) {
                string s = reader.ReadLine();
                while (s != null) {
                    if (s != null) {
                        wordList.Add(s);
                    }
                    s = reader.ReadLine();
                }
            }
            cache.Insert("WordList", wordList);
        }
        return wordList.FindAll(s => s.StartsWith(prefixText));
    }
}

